//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: PreLoadCommand.cpp,v 1.5 2004/11/12 15:27:55 jsnelson Exp $
//

#include "PreLoadCommand.hpp"

using namespace DbXml;
using namespace std;

string PreLoadCommand::getCommandName() const
{
  return "preload";
}

string PreLoadCommand::getBriefHelp() const
{
  return "Pre-loads the given container";
}

string PreLoadCommand::getMoreHelp() const
{
  return
    string("Takes the container name as an argument. This command uses the\n") +
    string("XmlManager::openContainer() method to open the container, and\n") +
    string("stores it in a vector. Since it is guarenteed that there is only\n") +
    string("one copy of a given XmlContainer, this effectively holds the\n") + 
    string("container open for the lifetime of the program.");
}

void PreLoadCommand::execute(Args &args, Environment &env)
{
  if(args.size() != 2) {
    throw CommandException("Wrong number of arguments");
  }
  containers_.push_back(env.db().openContainer(args[1], env.transactions() ? DBXML_TRANSACTIONAL : 0));
}

